"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.patchNextJsFileForPnpm = void 0;
const fs_1 = __importDefault(require("fs"));
// When you call next start it goes to the bin
// which has files made by next js that do not take into account pnpm
function patchNextJsFileForPnpm({ rootNodeModulesFile, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const main_path = '/node_modules/.bin';
        const mac_linux_pnpm_path = '/../../../../../../.pnpm/';
        const windows_pnpm_path = '/../../../.pnpm/';
        const windowsRegex = /(\\\.\.\\\.\.\\\.\.\\\.\.\\\.\.\\)|(\/\.\.\/\.\.\/\.\.\/\.\.\/\.\.\/)/g;
        const macLinuxRegex = /(\/\.\.\/\.\.\/\.\.\/\.\.\/\.\.\/)/g;
        // need this since macLinuxRegex would match the first five /../
        const doesPnpmExistMacLinuxRegex = /(\/\.\.\/\.\.\/\.\.\/\.\.\/\.\.\/\.\.\/\.pnpm)/g;
        let next = yield fs_1.default.promises.readFile(`${rootNodeModulesFile}/${main_path}/next`, 'utf-8');
        if (next.match(doesPnpmExistMacLinuxRegex) === null) {
            next = next.replace(macLinuxRegex, mac_linux_pnpm_path);
            yield fs_1.default.promises.writeFile(`${rootNodeModulesFile}/${main_path}/next`, next);
        }
        if (process.platform === 'win32') {
            let [nextCMD, nextPs] = yield Promise.all([
                fs_1.default.promises.readFile(`${rootNodeModulesFile}/${main_path}/next.CMD`, 'utf-8'),
                fs_1.default.promises.readFile(`${rootNodeModulesFile}/${main_path}/next.ps1`, 'utf-8'),
            ]);
            nextCMD = nextCMD.replace(windowsRegex, windows_pnpm_path);
            nextPs = nextPs.replace(windowsRegex, windows_pnpm_path);
            yield Promise.all([
                fs_1.default.promises.writeFile(`${rootNodeModulesFile}/${main_path}/next.CMD`, nextCMD),
                fs_1.default.promises.writeFile(`${rootNodeModulesFile}/${main_path}/next.ps1`, nextPs),
            ]);
        }
    });
}
exports.patchNextJsFileForPnpm = patchNextJsFileForPnpm;
